import sys

# parse script arguments
##########################
params_id = sys.argv[1]

if len(sys.argv) > 2:
    key_id = sys.argv[2]
else:
    key_id = '0'

sign_filename = sys.argv[3]

# load libraries
##########################
wave_lib_path = './lib/'
load(wave_lib_path + 'wave_rng.sage')
load(wave_lib_path + 'wave_verif.sage')

# load parameters
##########################
load('wave_params' + params_id + '.sage')

wave_data_path = './Data/' + params_id + '/'
key_suffix = params_id + '_' + key_id
Ht = load(wave_data_path + 'wave_pk' + key_suffix)
start, M = load(sign_filename)
end = start + M.nrows()

fail = 0
for seed in range(start, end):
    if seed > start and (seed - start) % 1000 == 0:
        print seed
    s = wave_random_vector(GF(3), n - (kU + kV), seed)
    e = M.row(seed - start)
    if not verif(e, s, Ht, w):
        print 'verification failed for seed ' + str(seed)
        fail += 1

print str(end - start) + ' signatures checked, ' + str(fail) + ' failures'
print 'seed in [' + str(start) + ', ' + str(seed) + ']'
