
def block_length(exponent, security):
    return 2 * round(security / 2 / exponent)

# assumes n even
def params(alpha, R, n):
    omega = 1 - alpha + sqrt((alpha - 1/3) * (alpha - 1/3 + 4/3 * R))
    RV = 1 / (alpha - 1/3) * ((1 - omega)^2 + omega^2 / 2 - 1/3)
    RU = 3 * omega - 2
    w, kV, kU = 2 * round(omega * n / 2), round(RV * n / 2), round(RU * n / 2)
    return w, kU, kV

alpha, R, exponent =  0.568141, 0.676, 0.0176898

security = int(sys.argv[1])

F = GF(3)
n = block_length(exponent, security)
delta = 0
w, kUp, kVp = params(alpha, R - 2 * delta / n, n)

# readjust alpha after rounding, better for rejection sampling ?
omega = float(w / n)
rateV = float(kVp / n * 2)
alpha = 1/3 + (1.5 * omega^2 - 2 * omega + 2 / 3) / rateV

print 'n = ' + str(n)
print 'w = ' + str(w)
print 'kU = ' + str(kUp + delta)
print 'kV = ' + str(kVp + delta)
print 'delta = ' + str(delta)
print 'alpha = ' + str(alpha)
