import hashlib

def dbase_inv(x, q):
    v = []
    while x > 0:
        v = [x % q] + v
        x = x // q
    return v

def dbase(x, q):
    v = []
    while x > 0:
        v += [x % q]
        x = x // q
    return v

def wave_randlist(q, length, seed, string):
    b = floor(512 / log(q, 2))
    i = 0
    x = []
    while len(x) < length:
        r = int(hashlib.sha512(string + str(seed) + "-" + str(i)).hexdigest(), base=16)
        i += 1
        if r >= q^b:
            continue
        v = dbase(r, q)
        x += v + [0] * (b - len(v))
    return x[:length]

def wave_random_vector(F, length, seed):
    q = F.cardinality()
    return vector(F, wave_randlist(q, length, seed, 'wave randlist'))

def wave_random_matrix(F, nrows, ncols, seed):
    q = F.cardinality()
    return matrix(F, [wave_randlist(q, ncols, seed, 'wave randkey' + str(i)) for i in range(nrows)])
