import sys

# parse script arguments
##########################
params_id = sys.argv[1]

# load libraries
##########################
wave_lib_path = './lib/'
load(wave_lib_path + 'wave_sampling.sage')

# load parameters
##########################
load('wave_params' + params_id + '.sage')

print 'parameters n, kU, kV, w, d = ' + str(n) + ', ' + str(kU) + ', ' + str(kV) + ', ' + str(w) + ', ' + str(delta)

rV, DV, q1, q1_t = precomp_V(sigmaV, alpha, int(n / 2), kV - delta, w)

print 'rejection rate for V'
print max(q1_t[i]/q1[i] for i in q1_t) - 1

t_min, t_max = min(rV), max(rV) + 1
rU, DU, q2, q2_t = precomp_U(sigmaU, epsilon, int(n / 2), kU - delta, w, t_min, t_max)
M = 0
for t in q1_t:
    M += q1_t[t] * max(q2_t[t][i]/q2[t][i] for i in q2_t[t])
print 'average rejection rate for U'
print M - 1

wave_data_path = './Data/' + params_id + '/'
filename = wave_data_path + 'wave_precomp_data' + params_id

print 'precomputation saved in file ' + filename + '.sobj'
save([rV, DV, rU, DU], filename)
