import sys

# parse script arguments
##########################
params_id = sys.argv[1]

if len(sys.argv) > 2:
    key_id = sys.argv[2]
else:
    key_id = '0'

nb = 1
if len(sys.argv) > 3:
    nb = int(sys.argv[3])
start = 0
if len(sys.argv) > 4:
    start = int(sys.argv[4])
end = start + nb

# load libraries
##########################
wave_lib_path = './lib/'
load(wave_lib_path + 'wave_keygen.sage')
load(wave_lib_path + 'wave_rng.sage')
load(wave_lib_path + 'wave_sign.sage')
load(wave_lib_path + 'wave_verif.sage')

# load parameters
##########################
load('wave_params' + params_id + '.sage')

wave_data_path = './Data/' + params_id + '/'
key_suffix = params_id + '_' + key_id

rV, DV, rU, DU = load(wave_data_path + 'wave_precomp_data' + params_id)

sk = load(wave_data_path + 'wave_sk' + key_suffix)
pk = load(wave_data_path + 'wave_pk' + key_suffix)

sign_filename = wave_data_path +  'sign' + key_suffix + '_' + str(start)
if end > start + 1:
    sign_filename += '-' + str(end)

M = matrix(GF(3), 0, n)
for seed in range(start, end):
    if seed > start and (seed - start) % 1000 == 0:
        save([start, M], sign_filename)
    s = wave_random_vector(GF(3), n - (kU + kV), seed)
    e = sign(s, sk, DV, DU, rV, rU, w, delta)
    if not verif(e, s, pk, w):
        print "fail: key " + key_suffix + ", seed " + str(seed)
    M = M.stack(e)

save([start, M], sign_filename)
print str(end - start) + ' signature(s) saved in file ' + sign_filename + '.sobj'
if end - start > 1:
    print 'seed in [' + str(start) + ', ' + str(seed) + ']'
else:
    print 'seed = ' + str(start)
